//+------------------------------------------------------------------+
//|                                      2Extreme4U Grid Builder.mq4 |
//|                     Copyright  2005, Siddiqi, Alejandro Galindo |
//|                                              http://elCactus.com | 
//+------------------------------------------------------------------+
//|                             added alert  -  LuisAY on 2013.04.23 | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Siddiqi, Alejandro Galindo"
#property link      "http://elCactus.com"

#property indicator_chart_window
extern int GridSpace= 250; //50;
extern bool UseAlert = true;
extern int AlertPointsAway = 20;
extern bool triggerAtEveryLevel = true;
int lastTime;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   double shift=0;
   double HighPrice=0;
   double LowPrice=0;
   
   double Divisor = 0.1/Point;
   
   HighPrice = MathRound(High[Highest(NULL,0,2, Bars - 2,  2)] * Divisor);
   //SL = High[Highest(MODE_HIGH, SLLookback, SLLookback)];
   LowPrice = MathRound(Low[Lowest(NULL,0,1, Bars - 1, 2)] * Divisor);
   for(shift=LowPrice;shift<=HighPrice;shift++)
   {
      ObjectDelete("Grid"+shift);   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int    counted_bars=IndicatorCounted();
   double I=0;
   double HighPrice=0;
   double LowPrice=0;
   int GridS=0;
   int SL=0;
//----    

   double Divisor = 0.1/Point;
   double bid   =iClose(Symbol(),Period(),0);

   HighPrice = MathRound(High[Highest(NULL,0,MODE_HIGH, Bars - 2, 2)] * Divisor);
   //SL = High[Highest(MODE_HIGH, SLLookback, SLLookback)];
   LowPrice = MathRound(Low[Lowest(NULL,0,MODE_LOW, Bars - 1, 2)] * Divisor);
   GridS = GridSpace / 10;
   double pointAway = AlertPointsAway / 10 / Divisor ;
   double x;
   for(I=LowPrice;I<=HighPrice;I++)
   {
	  //Print("mod(I, GridSpace): " + MathMod(I, GridS) + " I= " + I);
	  //Print(LowPrice + " " + HighPrice);
	  if (MathMod(I, GridS) == 0) 
	  {	     
         if (ObjectFind("Grid"+I) != 0)
         {                     
            ObjectCreate("Grid"+I, OBJ_HLINE, 0, Time[1], I/Divisor);            
            ObjectSet("Grid"+I, OBJPROP_STYLE, STYLE_DOT);
            ObjectSet("Grid"+I, OBJPROP_COLOR, Black);            
         }
		 //MoveObject(I + "Grid", OBJ_HLINE, Time[Bars - 2], I/1000, Time[1], I/1000, MediumSeaGreen, 1, STYLE_SOLID);
	  }

// ============ as it makes sense to me
	 if (MathMod(I, GridS * 10 ) == 0 && UseAlert && !triggerAtEveryLevel )
	 {
     ObjectSet("Grid"+I, OBJPROP_COLOR, YellowGreen);  
	  x = I/Divisor;
	  if ( bid + pointAway > x && bid - pointAway < x ) 
	  {
	     if ( lastTime != Time[1] ) { 
	        Alert( "Grid Alert on ",Symbol()," / M",Period(),"\n -= Grid Builder =-" ); 
	        SendMail (StringConcatenate(Symbol()," Grid Builder "),"Grid Alert");
	     }
	     lastTime = Time[1];
	   }
     }
// =======================================
// ============ as it makes sense to you
	 if (MathMod(I, GridS ) == 0 && UseAlert && triggerAtEveryLevel )
	 {
	  x = I/Divisor;
	  if ( bid + pointAway > x && bid - pointAway < x ) 
	  {
	     if ( lastTime != Time[1] ) { 
	        Alert( "Grid Alert on ",Symbol()," / M",Period(),"\n -= Grid Builder =-" ); 
	         SendMail (StringConcatenate(Symbol()," Grid Builder "),"Grid Alert");
	        }
	     lastTime = Time[1];
	   }
	   }
// =======================================

	 
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+